#include <inttypes.h>

extern int verbose ;
typedef uint32_t base ;

#define NMAX (sizeof(base)*8)

typedef struct {
  int id,n,depth ;
  int *t ;
} subtask_t ;

subtask_t *copy_arg(subtask_t *z) ;
void free_arg(subtask_t *z) ;

void print_subtask(FILE *fp,subtask_t *z) ;
subtask_t *read_subtask(FILE *fp) ;

typedef uint32_t count_t ;
#define PRC PRIu32

/* Subtask generator, returns number of subtasks */
typedef void emit_t(subtask_t *z) ;
int generate_subtasks(int n, int depth, emit_t emit) ;

/* Run a subtask */
count_t run_subtask(subtask_t *z) ;

/* Run complete task */
count_t run_task(int n) ;
